# Based on the excellent work by Tom Moretel
# $Id$
# "uname -r" output of the kernel to build for, the running one
# if none was specified with "--define 'kernel <uname -r>'"
%{!?kernel: %{expand: %%define kernel %(uname -r)}}
%define kversion %(echo %{kernel} | sed -e s/smp// -)
%define krelver  %(echo %{kversion} | tr -s '-' '_')
%if %(echo %{kernel} | grep -c smp)
        %{expand:%%define ksmp -smp}
%endif

%{!?distro: %{expand: %%define distro fc2}}

Summary: Driver for the Zaptel telephony adapters.
Name: zaptel
Version: 1.0.2
Release: %{distro}.2
License: GPL
Group: System Environment/Kernel
URL: http://www.digium.com/index.php?menu=documentation
Source0: ftp://ftp.digium.com/pub/zaptel/%{name}-%{version}.tar.gz
Source1: zaptel-makedev.d.txt
Source2: README.init.modprobe
Patch0: zaptel-1.0.2-makefile.patch
Patch1: zaptel-1.0.2-init.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Drivers for Digium's Zaptel-based telephony drivers. The drivers
offer support for Pseudo-TDM features.

This package contains the Zaptel basic development files and /dev entries.

%package -n kernel%{?ksmp}-module-zaptel
Summary: Zaptel telephony adapter kernel drivers.
Release: %{release}_%{krelver}
Group: System Environment/Kernel
Requires: zaptel
Requires: kernel%{?ksmp} = %{kversion}, /sbin/depmod
Provides: kernel-modules
%{?ksmp:Provides: kernel-module-zaptel = %{version}-%{release}}

%description -n kernel%{?ksmp}-module-zaptel
Drivers for Digium's Zaptel-based telephony drivers.  The
drivers offer support for Pseudo-TDM features.

This package contains the Zaptel kernel modules for the Linux kernel
package %{kversion} (%{_target_cpu}%{?ksmp:, SMP}).

%prep
%setup -q 
%patch -p1
%patch1 -p1
cp %{SOURCE2} .

%build
make KINCLUDES=/lib/modules/%{kversion}/build/include KSMP=%{?ksmp:-D__SMP__} \
     ECHO_CANCELLER=-DECHO_CAN_MARK2 KVERSION=%{kernel}

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/%{_includedir}/linux
mkdir -p %{buildroot}/%{_sysconfdir}
touch %{buildroot}/%{_sysconfdir}/modprobe.conf

# We trick the Makefile into thinking that devfs is being used,
# thereby preventing the Makefile from attempting to build devices,
# which will fail because the RPM is being built by a non-root user
# (as all good RPMs should be.)
make install INSTALL_PREFIX=%{buildroot} KVERSION=%{kernel} DYNFS=fake

# Run "make config"
make config INSTALL_PREFIX=%{buildroot} KVERSION=%{kernel} DYNFS=fake

# Move some of the "installed" files in to better places for RPM use
mkdir -p %{buildroot}%{_datadir}/%{name}
mv %{buildroot}%{_sysconfdir}/modprobe.conf %{buildroot}%{_datadir}/%{name}
rm %{buildroot}%{_sysconfdir}/modprobe.conf.bak

# Install and generate device stuff in a way that makes rpmbuild happy
install -m 644 -D %{SOURCE1} %{buildroot}%{_sysconfdir}/makedev.d/zaptel
cp -a %{_sysconfdir}/makedev.d/00macros %{buildroot}%{_sysconfdir}/makedev.d
/dev/MAKEDEV \
    -c %{buildroot}%{_sysconfdir}/makedev.d \
    -d %{buildroot}/dev -M zaptel | sed 's|%{buildroot}||g' > device.list
rm -f %{buildroot}%{_sysconfdir}/makedev.d/00macros

%clean
rm -rf %{buildroot}

%post
/sbin/ldconfig
/sbin/chkconfig --add zaptel
/sbin/chkconfig zaptel off
echo -e  "Please read %{_docdir}%{name}/README.init.modprobe\n   for the zaptel driver startup alternatives !"

%post -n kernel%{?ksmp}-module-zaptel
/sbin/depmod -a -F /boot/System.map-%{kernel} %{kernel} >/dev/null 2>&1 || :

%preun
/sbin/chkconfig --del zaptel

%files -f device.list
%defattr(-,root,root,-)
%doc ChangeLog README.fxsusb README.Linux26 README.init.modprobe
%config(noreplace) %{_sysconfdir}/zaptel.conf
%config(noreplace) %{_sysconfdir}/sysconfig/zaptel
%{_sysconfdir}/makedev.d/zaptel
%{_sysconfdir}/sysconfig/network-scripts/ifup-hdlc
%{_initrddir}/zaptel
%{_includedir}/*
%{_libdir}/libtonezone.so*
/sbin/*

%files -n kernel%{?ksmp}-module-zaptel
%defattr(-,root,root,-)
/lib/modules/%{kernel}/misc/*
%{_datadir}/%{name}/modprobe.conf

%changelog
* Mon Nov 22 2004 Gabriel L. Somlo <somlo@acns.colostate.edu>
- modules.conf renamed to modprobe.conf
- zaptel service set to off by default
- pre-uninstall entry added: remove init script before uninstall
- README.init.modprobe added to documentation

* Thu Nov 18 2004 Gabriel L. Somlo <somlo@acns.colostate.edu>
- patched zaptel.init to use modprobe instead of insmod/rmmod

* Tue Nov 16 2004 Gabriel L. Somlo <somlo@acns.colostate.edu>
- Updated to version 1.0.2
- specify %{_libdir}/libtonezone.so* to prevent including %{_libdir}/debug/*

* Mon Sep 27 2004 Joshua M. Thompson <jmt@purplehat.net>
- Updated for FC1/FC2
- Patch zaptel Makefile to properly build for kernel versions
  other than the currently running kernel (by letting you
  set KVERSION on the command line)
- Patch zaptel Makefile to allow DYNFS to be set on the
  command line
- Patch zaptel Makefile to build on 2.6 without kernel source

* Thu Sep 23 2004 Gregory Boehnlein <damin@nacs.net>
- Updated to version 1.0.0
- Drank beer at Astricon

* Thu Aug 12 2004 Gregory Boehnlein <damin@nacs.net>
- Updated to version 1.0-RC2

* Sat Jul 17 2004 Gregory Boehnlein <damin@nacs.net>
- Updated to version 1.0-RC1

* Thu May 27 2004 Gregory Boehnlein <damin@nacs.net>
- Updated to version 0.9.1

* Wed Feb 04 2004 Gregory Boehnlein <damin@nacs.net>
- Updated to version 0.8.1

* Sat Jan 31 2004 Gregory Boehnlein <damin@nacs.net>
- Added "make config" patch and logic
- Added /etc/rc.d/init.d/zaptel and ifup-hdlc
- Added post-install chkconfig to auto-load zaptel modules
- Updated build environment to ensure wider compatibilty
- Modules now actually load into a stock kernel! ;)

* Mon Jan 26 2004 Gregory Boehnlein <damin@nacs.net>
- Updated changelog entry to enable build on Fedora Core 1 <wrl@express.org>
- Made the decsision to use Dist Specific version numbers (_fc1,_rh9,_rh8,_rh73)

* Sat Jan 24 2004 Gregory Boehnlein <damin@nacs.net>
- added doc macros
- zaptel.spec now builds cleanly on RH73 and RH9

* Thu Jan 22 2004 Gregory Boehnlein <damin@nacs.net>
- Updated Tom's work to use the latest code from Digium

* Tue Nov 11 2003  <tom-rpms@moertel.com> 
- Initial build, based heavily on Matthias Saou's alsa-driver.spec.
